C  This program scans the output of the ZEFSA3D program, 
C  checking coordination sequences and generating a 
C  reduced output file for plotting using DISPLAY3D

C Written by Michael W. Deem 2 September 1988.
C Modified 11.06.1989 jmn
C Modified 30 March 1990 by M. W. Deem.
C Modified 7 July 1990 by M. W. Deem.
C Corporate Research, Exxon Research & Engineering, Annandale, NJ, USA.

      program SCAN3D

      include 'zefsa3d.inc'

      logical ok, WRFILE, RDFILE, I_GRID, GROUP
      integer*2 i, j, k, minocc, maxocc, sum1, sum2
      real*4 e_min, e, t

      integer*2 n_save, save_nt(MAX_SAVE),
     |          coord(MAX_COOR, MAX_UNIQ, MAX_SAVE),
     |          coors(MAX_UNIQ, MAX_SAVE), cooto(MAX_SAVE)
      common /savedj/ n_save, save_nt, coord, coors, cooto

      real*4  save_e(MAX_SAVE), save_pos(3,MAX_ATOMS,MAX_SAVE),
     |     save_t(MAX_SAVE), save_cyl(3,MAX_PORE,MAX_SAVE),
     |     save_sph(3,MAX_PORE,MAX_SAVE)
      common /savedt/ save_e, save_pos, save_t, save_cyl,
     |                save_sph

      external RDFILE, WRFILE, CONST, GROUP, I_XYZ, I_GRID,
     |         ADD_POS

      print *,'Reducing output of ZEFSA3D program'
      print *,'Author: Michael W. Deem'
      print *,'Corporate Research, Exxon Research & Engineering'
      PI = 4.0 * atan(1.0)
      k = 1
      ok = RDFILE(k)
      if (ok) call CONST()
      if (ok) ok = GROUP()
      if (ok) call I_XYZ()
      if (ok) ok = I_GRID()
      if (.not. ok) stop
      j = 0
      print *,'Enter maximum energy for displayed structures'
      read *, e_min
      n_save = 0
10      read(2,*,END=50) e, t, minocc, maxocc, n_actual
        do 20 i = 1, n_atoms
20        read(2,*) a_pos(1,i), a_pos(2,i), a_pos(3,i)
        do 30 i = 1, n_cyl
30        read(2,*) cyl_pos(1,i), cyl_pos(2,i), cyl_pos(3,i)
        do 40 i = 1, n_sph
40        read(2,*) sph_pos(1,i), sph_pos(2,i), sph_pos(3,i)
        print *,'Examining configuration'
        if (e .lt. e_min) call ADD_POS(e, t, n_actual)
        goto 10
50    minocc = MAX_CLOSE
      maxocc = 0
      do 55 i = 1, n_atoms*n_symm, n_symm
        minocc = min(minocc, n_bond(i))
55      maxocc = max(maxocc, n_bond(i))
      do 100 i = 1, n_save
        print *
        print *, save_e(i), save_t(i), minocc, maxocc, save_nt(i)
        write(3,*) save_e(i), save_t(i), minocc, maxocc, save_nt(i)
        sum2 = 0
        do 70 j = 1, n_atoms
          sum1 = 0
          do 60 k = 1, MAX_COOR
60          sum1 = sum1 + coord(k,j,i)
          sum2 = sum2 + sum1
          write(3,*) (save_pos(k,j,i), k=1,3)
70        write(*,200) (coord(k,j,i),k=1,MAX_COOR), sum1
        do 80 j = 1, n_cyl
80       write(3,*) (save_cyl(k,j,i),k=1,3)
        do 90 j = 1, n_sph
90        write(3,*) (save_sph(k,j,i),k=1,3)
100     write(*,210) sum2
      close(3)
      print *, n_save,' unique topologies'
200   format(1X, 10 I4, I6)
210   format(1X, 40x, I6)
      end


C This routine updates the saved topologies with the current a_pos data
      subroutine ADD_POS(e, t, nt)

      include 'zefsa3d.inc'

      integer*2 nt	
      real*4 t, e

      logical ok, ltmp, DO_SHELL, CHK_DGN, MK2_CON, MK_UNI, MK_DGN
      integer*2 shell(MAX_COOR, MAX_ATOMS), i, j, k, n2_bond(MAX_ATOMS)

      integer*2 n_save, save_nt(MAX_SAVE),
     |          coord(MAX_COOR, MAX_UNIQ, MAX_SAVE),
     |          coors(MAX_UNIQ, MAX_SAVE), cooto(MAX_SAVE)
      common /savedj/ n_save, save_nt, coord, coors, cooto

      real*4  save_e(MAX_SAVE), save_pos(3,MAX_ATOMS,MAX_SAVE),
     |     save_t(MAX_SAVE), save_cyl(3,MAX_PORE,MAX_SAVE),
     |     save_sph(3,MAX_PORE,MAX_SAVE)
      common /savedt/ save_e, save_pos, save_t, save_cyl,
     |                save_sph

      external MOD_POS, MK_DGN, CHK_DGN, MK2_CON, MK_UNI, DO_SHELL,
     |         SORT_SH

C store specified coordinate numbers
      do 5 i = 1, n_atoms*n_symm
5       n2_bond(i) = n_bond(i)
C create coordination sequence
      call MOD_POS()
      ok = MK_DGN(a_pos)
      if (ok) ok = CHK_DGN()
      ltmp = .true.
      if (ok) ok = MK2_CON(ltmp)
      if (ok) ok = MK_UNI(n_actual)
      if (.not. ok) goto 90
      do 10 i = 1, n_atoms
        j = (i-1)*n_symm+1
        if (.not. DO_SHELL(atommap(j), shell(1,i), MAX_COOR, MAX_COOR,
     |                     n_actual))
     |     goto 90
10      continue
      call SORT_SH(shell, MAX_COOR, MAX_ATOMS, MAX_COOR, n_atoms)
      i = 0
C find this sequence in those saved
20    i = i + 1
      if (i .gt. n_save) goto 40
        do 30 j = 1, n_atoms
          do 30 k = 1, MAX_COOR
            if (coord(k,j,i) .ne. shell(k,j)) goto 20
30          continue
      if (e .gt. save_e(i)) goto 90
C replace topology with one of a lower energy
40    if (i .gt. MAX_SAVE) goto 100
      do 60 j = 1, n_atoms
        do 50 k = 1, MAX_COOR
50        coord(k,j,i) = shell(k,j)
        save_pos(1,j,i) = a_pos(1,j)
        save_pos(2,j,i) = a_pos(2,j)
60      save_pos(3,j,i) = a_pos(3,j)
      do 70 j = 1, n_cyl
         save_cyl(1,j,i) = cyl_pos(1,j)
         save_cyl(2,j,i) = cyl_pos(2,j)
70       save_cyl(3,j,i) = cyl_pos(3,j)
      do 80 j = 1, n_sph
         save_sph(1,j,i) = sph_pos(1,j)
         save_sph(2,j,i) = sph_pos(2,j)
80       save_sph(3,j,i) = sph_pos(3,j)
      save_t(i) = t
      save_e(i) = e
      save_nt(i) = nt
      if (i .gt. n_save) n_save = n_save + 1
C      print *,'n_save ',n_save
C restore specified coordination numbers
90    do 95 i = 1, n_atoms*n_symm
95      n_bond(i) = n2_bond(i)
      return
100   print *,'Too many unique topolgies in the file'
      goto 90
      end
