C These routines are used by zefsa3d in the powder pattern mode.

C Written by Michael W. Deem 1 August 1990.

C This function returns the length of the first group of contiguous, non-space
C characters in the passed string. 
      integer function LENGTH(string)

      implicit none

      character string*(*)

      integer i

      i = 1
10    if (string(i:i) .eq. ' ') goto 20
        i = i + 1
      goto 10
20    LENGTH = i-1
      return
      end


C This function compares a string with an array of keys and returns the
C index of the key that matches the first characters of the string.
      integer*2 function CHOICE(flag, list, n)

      implicit none

      integer*2 n
      character*(*) flag, list(*)

      integer*2 i, l, LENGTH
      external LENGTH

      i = 1
10    if (i .gt. n) goto 20
      if (LENGTH(flag) .eq. LENGTH(list(i)) .and.
     |      index(flag, list(i)(1:LENGTH(list(i)))) .eq. 1) goto 20
        i = i + 1
      goto 10
20    if (i .gt. n) then
        i = -1
      else
        l = LENGTH(list(i))+1
        if (flag(l:l) .ne. ' ') i = -1
      end if
      CHOICE = i
      return
      end


C This routine reads in the data from unit 10.
C It uses unit 1 as a temporary file.
      logical function RD2FILE()

      include 'zefsa3d.inc'
      include 'zefsa3d-b.inc'

      character message*70, line*80, line2*80
      character*80 list(10)
      integer*2 i, j, m, k, CHOICE, unit1, unit10

      external SCANS, CHOICE, GETLNE

      print *,'Reading input PXD data file from unit 10'
      RD2FILE = .false.
      unit1 = 1
      unit10 = 10
      open(unit1,status='SCRATCH',ERR=240)
C actually read in the input file
      message =
     | 'Invalid specification of random number seed'
      read(unit10,*,ERR=200) r_seed
      message =
     | 'Invalid specification of splitting temperatures'
      read(unit10,*,ERR=200) temp_1, temp_2
      message =
     | 'Invalid specification of temperature decrement factors'
      read(unit10,*,ERR=200) tfact1, tfact2, tfact3
      message = 'Invalid jiggle step parameters'
      read(unit10,*,ERR=200) step_a, step_b, step_m
      message = 'Invalid reciprocal space step parameters'
      read(unit10,*,ERR=200) rec_a, rec_b, rec_m
      message =
     | 'Invalid specification of number of atoms or symmetry operations'
      read(unit10,*,ERR=200) n_atoms, n_symm
      message = 'Invalid number of atoms'
      if (n_atoms .lt. 1 .or. n_atoms .gt. MAX_UNIQ) goto 200
      message = 'Invalid number of symmetry operators'
      if (n_symm .lt. 1 .or. n_symm .gt. MAX_SYMM) goto 200
      message = 'Too many total atoms'
      if (n_atoms*n_symm .gt. MAX_ATOMS) goto 200
      message = 'Invalid specification of cell constants'
      read(unit10,*,ERR=200) c_a, c_b, c_c
      message = 'Invalid specification of cell angles'
      read(unit10,*,ERR=200) c_alpha, c_beta, c_gamma
      c_alpha = c_alpha * PI / 180.0
      c_beta = c_beta * PI / 180.0
      c_gamma = c_gamma * PI / 180.0
      do 50 m = 1, n_symm
        write(message,'(A,I3)')
     |        'Invalid specification of symmetry operation ',m
        read(unit10,*,ERR=200)
     |      ((symm_m(j,i,m),j=1,3),i=1,3), (symm_v(i,m),i=1,3)
C        write(*,110) m,
C     |      ((symm_m(j,i,m),j=1,3),i=1,3), (symm_v(i,m),i=1,3)
50      continue
C see if centrosymmetric
      message = 'Invalid specification of centrosymmetry'
      call GETLNE(unit10, line, 200)
      list(1) = 'CENTROSYMMETRIC '
      list(2) = 'NONCENTROSYMMETRIC '
      i = 2
      i = CHOICE(line, list, i)
      if (i .lt. 1 .or. i .gt. 2) goto 200
      centro = i .eq. 1
C read in the types of the unique atoms
      do 60 i = 1, n_atoms
        write(message,'(A,I3)')
     |      'Invalid specification of parameters for atom  ',i
        call GETLNE(unit10, line, 200)
        call SCANS(line, line2, 200)
        a_name(i) = line2
        write(unit1,100,ERR=250) line
        rewind(unit1,ERR=260)
        read(unit1,*,ERR=200) a_occup(i), a_b(i),
     |            ((a_m(j,k,i),j=1,3),k=1,3), (a_v(j,i),j=1,3)
60      rewind(unit1,ERR=260)
      message = 'Invalid specification of radiation type'
      call GETLNE(unit10, line, 200)
      call SCANS(line, line2,200)
      i = 3
      list(1) = 'X-RAY '
      list(2) = 'NEUTRON '
      list(3) = 'X-RAY+NEUTRON '
      rad_type = CHOICE(line2, list, i)
      if (rad_type .ne. X_RAY .and. rad_type .ne. NEUTRON .and.
     |    rad_type .ne. BOTH) goto 200
      message = 'Invalid specification of radiation wavelength'
      write(unit1,100,ERR=250) line
      rewind(unit1,ERR=260)
      if (rad_type .ne. BOTH) then
        read(unit1,*,ERR=200) rad_lamb
      else
        read(unit1,*,ERR=200) rad_lamb, rad2_lamb
      end if
      rewind(unit1,ERR=260)
      message = 'Invalid number of reciprocal space spots'
      read(unit10,*,ERR=200) n_spot
      message = 'Too many reciprocal space spots'
      if (n_spot .gt. MAX_SPOT) goto 200
      do 70 i = 1, n_spot
        write(message,'(A,I3)')
     |      'Invalid reciprocal space information for spot ',i
        if (rad_type .ne. BOTH) then
          read(unit10,*,ERR=200) rec_h(i), rec_k(i), rec_l(i), 
     |                         rec_mult(i), rec_int(i), rec_sig(i)
        else
          read(unit10,*,ERR=200) rec_h(i), rec_k(i), rec_l(i), 
     |                         rec_mult(i), rec_int(i), rec_sig(i),
     |                         rec2_int(i), rec2_sig(i)
        end if
70      continue
      close(unit1)
      RD2FILE = .true.
      return
100   format(A)
110   format(1X, I3, 100 F6.2)
120   format(A, I3)
200   print *,'Error: ',message
210   close(unit10)
      close(unit1)
      return
220   print *,'Error reading 80 character text lines from input file'
      goto 210
230   print *,
     | 'Error writing 80 character text lines to position output file'
      goto 210
240   print *,'Error opening temporary file'
      goto 210
250   print *,'Error writing to temporary file'
      goto 210
260   print *,'Error rewinding temporary file'
      goto 210
      end


C This routine gets the structure factor constants used in determining
C the structure factor.  Unit 1 is used to read in the fixed-name
C file "scatfact.dat".
      logical function READSFC()

      include 'zefsa3d.inc'
      include 'zefsa3d-b.inc'

      logical ok
      logical hash(MAX_UNIQ+1), list(MAX_UNIQ+1)
      integer*2 i, i2, j, m, value, LENGTH
      character*4 atom_l(MAX_UNIQ), name, line*125
      external LENGTH


c-------------------------------new definitions-------------------------c
        character*256 specfile
        character*256 buffer
        logical there
        integer nblength
c-----------------------------------------------------------------------c

      print *, 'Reading structure factor file "scatfact.dat"'
      READSFC = .false.
C zero hash table
      do 10 i = 1, MAX_UNIQ
        list(i) = .false.
10      hash(i) = .false.
      m = 0
C determine all distinct atom types
      do 30 i = 1, n_atoms
        name = a_name(i)
        value = mod(ichar(name(1:1)) + ichar(name(2:2)) +
     |            ichar(name(3:3)) + ichar(name(4:4)), MAX_UNIQ) + 1
C see if this name might have been seen already
        if (.not. hash(value)) then
C nope, not seen; enter it in
          m = m + 1
          atom_l(m) = name
C          print *,'adding ',name
          a_scat(i) = m
          hash(value) = .true.
        else
C maybe seen
          i2 = 0
20          i2 = i2 + 1
C find if it is already entered
            if (i2 .le. m .and. atom_l(i2) .ne. name) goto 20
          if (i2 .le. m) then
C yes, already seen
            a_scat(i) = i2
          else
C no, not seen; enter it in list
            m = m + 1
            if (m .gt. MAX_SCAT) goto 230
            atom_l(m) = name
C            print *,'adding ',name
            a_scat(i) = m
          end if
        end if
30      continue
      n_scat = m
C now find data for each atom type in file
C pass through file only once

       buffer = "."
      specfile=buffer(1:nblength(buffer))//'/'
      specfile=specfile(1:nblength(specfile))//'scatfact.dat'
      inquire(file=specfile,exist=there)
      if(.not.there)then
               print *,'Cannot find the scatfact.dat file'
               print *,'ZeFsA cannot proceed'
               goto210
      endif
c-----------------------------------------------------------------------c

      open(1,file=specfile, status='old',ERR=210)
40        read(1, 300, END=60, ERR=200) line
          name = line(7:10)
C          print *, 'reading ',name
          value = mod(ichar(name(1:1)) + ichar(name(2:2)) +
     |              ichar(name(3:3)) + ichar(name(4:4)), MAX_UNIQ) + 1
C see if this is one of the distinct atoms
          if (hash(value)) then
            i = 0
50           i = i + 1
              if (i .le. n_scat  .and.  name .ne. atom_l(i))
     |            goto 50
C check to see if this data needed and not alread read in
            if (i .le. n_scat .and. .not. list(i)) then
C mark this atom's data as read in
              list(i) = .true.
C and read it in
              if (rad_type .eq. X_RAY .or. rad_type .eq. BOTH)
     |           read(line,310,ERR=220) (x_sf(j,i), j=1, 9)
              if (rad_type .eq. NEUTRON .or. rad_type .eq. BOTH)
     |          read(line,320,ERR=220) n_sf(i)
            end if
          end if
          goto 40
60    close(1,ERR=240)
C see if all atoms' data read in
      ok = .true.
      do 70 i = 1, n_scat
        if (.not. list(i)) then
          ok = .false.
          write(*,330) atom_l(i)
        end if
70      continue
      if (ok) then
        READSFC = .true.
        print *, 'Structure factor data read in'
      end if
      return
200   print *, 'Structure factor file defective'
      close(1,ERR=240)
      return
210   print *, 'Structure factor file not present'
      return
220   print *, 'Error reading structure factor data'
      close(1,ERR=240)
      return
230   print *,'Too many unique types of atoms'
      close(1,ERR=240)
      return
240   print *,'Unable to close structure factor file'
      return
300   format(A)
310   format(T11, 10F11.6, I3)
320   format(T110, F11.6)
330   format(1X,'Data for ',A,' not present in structure factor file')
      end


C This routine writes out the data read in.
      subroutine WR2FILE()

      include 'zefsa3d.inc'
      include 'zefsa3d-b.inc'

      character*30 list(10)
      integer*2 i, j, k

      print *, r_seed
      print *, temp_1, temp_2
      print *, tfact1, tfact2, tfact3
      print *, step_a, step_b, step_m
      print *, rec_a, rec_b, rec_m
      print *, n_atoms, n_symm
      print *, c_a, c_b, c_c
      print *, c_alpha*180.0/PI, c_beta*180.0/PI, c_gamma*180.0/PI
      do 10 i = 1, n_symm
10      write(*,100) 
     |      ((symm_m(k,j,i),k=1,3),j=1,3), (symm_v(j,i),j=1,3)
      do 20 i = 1, n_atoms
20      write(*,120) a_name(i), a_occup(i), a_b(i),
     |            ((a_m(j,k,i),j=1,3),k=1,3), (a_v(j,i),j=1,3)
      list(1) = 'X-RAY '
      list(2) = 'NEUTRON '
      list(3) = 'X-RAY+NEUTRON '
      if (rad_type .ne. BOTH) then
        print *, list(rad_type), rad_lamb
      else
        print *, list(rad_type), rad_lamb, rad2_lamb
      end if
      print *, n_spot
      do 30 i = 1, n_spot
        if (rad_type .ne. BOTH) then
          write(*,110) rec_h(i), rec_k(i), rec_l(i), rec_mult(i),
     |                 rec_int(i), rec_sig(i)
        else
          write(*,110) rec_h(i), rec_k(i), rec_l(i), rec_mult(i),
     |                 rec_int(i), rec_sig(i),
     |                 rec2_int(i), rec2_sig(i)
        end if
30      continue
      do 40 i = 1, n_atoms
        j = a_scat(i)
        print *,'a_scat ',j
        if (rad_type .eq. X_RAY) then
          write(*,120) a_name(i), (x_sf(k,j),k=1,9)
        else if (rad_type .eq. NEUTRON) then
          write(*,120) a_name(i), n_sf(j)
        else
          write(*,120) a_name(i), (x_sf(k,j),k=1,9), n_sf(j)
        end if
40      continue
      return
100   format(14F8.5)
110   format(14F12.5)
120   format(A,14F8.5)
      end


C This routine creates the data arrays for Oxygens created during 
C geometric optimization.
C The Oxygens are assumed to be of scattering type a_scat(n_atoms)
C The matrix/vectors are copied from the n_atoms position--this probably should
C be the identity matrix.
      subroutine INITPXD()

      include 'zefsa3d.inc'
      include 'zefsa3d-b.inc'

      integer*2 i, j

      do 20 i = n_atoms+1, MAX_UNIQ
        do 10 j = 1, 3
          a_v(j,i) = a_v(j,n_atoms)
          a_m(1,j,i) = a_m(1,j,n_atoms)
          a_m(2,j,i) = a_m(2,j,n_atoms)
10        a_m(3,j,i) = a_m(3,j,n_atoms)
        a_scat(i) = a_scat(n_atoms)
        a_name(i) = a_name(n_atoms)
20      a_b(i) = a_b(n_atoms)
      return
      end


C This routine creates the pointer that tells where the intensity of
C spot i is summed into.
C This pointer is defined as follows: if intensity i as negative, that
C spot's intensity will be summed with the next.  The first of the
C possibly two intensities is used.
C It also computes the sum of the intensities.
      logical function SPOT_PNT()

      include 'zefsa3d.inc'
      include 'zefsa3d-b.inc'

      integer*2 i, i0

      SPOT_PNT = .false.
      if (rec_int(n_spot) .lt. 0.0) goto 40
      do 10 i = n_spot, 1, -1
        if (rec_int(i) .ge. 0.0) then
          i0 = i
        end if
10      i_point(i) = i0
      rec_isum(1) = 0.0
      if (rec_int(1) .gt. 0.0) rec_isum(1) = rec_int(1)
      do 20 i = 2, n_spot
        rec_isum(i) = rec_isum(i-1)
20      if (rec_int(i) .gt. 0.0)
     |        rec_isum(i) = rec_isum(i) + rec_int(i)
      if (rad_type .eq. BOTH) then
        rec2_isum(1) = 0.0
        if (rec2_int(1) .gt. 0.0) rec2_isum(1) = rec2_int(1)
        do 30 i = 2, n_spot
          rec2_isum(i) = rec2_isum(i-1)
30        if (rec2_int(i) .gt. 0.0)
     |          rec2_isum(i) = rec2_isum(i) + rec2_int(i)
      end if
      SPOT_PNT = .true.
      return
40    print *,'The last spot must have a nonnegative intensity'
      return
      end


C This routine determines the reciprocal distance**2 of each spot.
C It also calculates the correction factor--polarization or Lorentz--
C associated with the radiation type.
      subroutine GET_Q2()

      include 'zefsa3d.inc'
      include 'zefsa3d-b.inc'

      integer*2 i
      real*4 x, y, z

      do 10 i = 1, n_spot
        x = rec_x1 * rec_h(i)
        y = rec_y2 * rec_h(i) + rec_y1 * rec_k(i)
        z = rec_z3 * rec_h(i) + rec_z2 * rec_k(i) + rec_z1 * rec_l(i)
10      rec_q2(i) = x*x + y*y + z*z
      do 20 i = 1, n_spot
        x = asin(0.5*rad_lamb * sqrt(rec_q2(i)))
        if (rad_type .eq. X_RAY .or. rad_type .eq. BOTH) then
C incorporate the polarization factor and the Lorentz factor for X-rays
          rec_cor(i) = 0.5 * (1.0 + cos(2*x)*cos(2*x)) /
     |                     (sin(x)*sin(2.0*x))
        else
C incorporate the Lorentz factor for neutrons
          rec_cor(i) = 1.0 / (sin(x)*sin(2.0*x))
        end if
C incorporate the Lorentz factor for neutrons
        x = asin(0.5*rad2_lamb * sqrt(rec_q2(i)))
        if (rad_type .eq. BOTH)
     |           rec2_cor(i) = 1.0 / (sin(x)*sin(2.0*x))
20      continue
      return
      end


C This routine determines the scattering factors for each scattering type
C at each spot.  The scattering factor is then multiplied by the Debye-
C Waller factor at each spot.
C It also determines the scattering types for each of
C the n_atoms*n_symm atoms
      subroutine GET_SCAT()

      include 'zefsa3d.inc'
      include 'zefsa3d-b.inc'

      integer*2 i, j, k
      real*4 qq

C determine scattering factors for each atom type
C This formula comes from p. 71 of "International Tables for X-ray
C Crystallography, Vol. IV" (The Kynoch Press: Birmingham, England), 1974.
C sin(theta) / lambda = 1/2d
      do 10 i = 1, n_spot
        qq = 0.25D0 * rec_q2(i)
        do 10 j = 1, n_atoms
          k = a_scat(j)
          if (rad_type .eq. X_RAY .or. rad_type .eq. BOTH) then
            scat_deb(j,i) = x_sf(1,k) * exp(-x_sf(2,k) * qq) +
     |                      x_sf(3,k) * exp(-x_sf(4,k) * qq) + 
     |                      x_sf(5,k) * exp(-x_sf(6,k) * qq) + 
     |                      x_sf(7,k) * exp(-x_sf(8,k) * qq) + 
     |                      x_sf(9,k)
          else
            scat_deb(j,i) = n_sf(k)
          end if
          if (rad_type .eq. BOTH) then
            scat2_deb(j,i) = n_sf(k)
            scat2_deb(j,i) = exp(-a_b(j)*qq) * scat2_deb(j,i)
          end if
10        scat_deb(j,i) = exp(-a_b(j)*qq) * scat_deb(j,i)
      return
      end


C This routine multiplies the h,k,l by 2PI
      subroutine MULT_PI2()

      include 'zefsa3d.inc'
      include 'zefsa3d-b.inc'

      integer*2 i
      real*4 PI2

      PI2 = 2.0 * PI
      do 10 i = 1, n_spot
        rec_h(i) = PI2 * rec_h(i)
        rec_k(i) = PI2 * rec_k(i)
10      rec_l(i) = PI2 * rec_l(i)
      return
      end


C This routine calculates the intensities at each spot
      subroutine GET_INT(inten, scat, n)

      include 'zefsa3d.inc'
      include 'zefsa3d-b.inc'

      integer*2 n
      real*4 inten(MAX_SPOT), scat(MAX_UNIQ, MAX_SPOT)

      integer*2 i, j, k
      real*4 fr(MAX_SPOT), fi(MAX_SPOT), fact, x, y, z, dot, tmp

C zero scattering array
C remember that if a structure is centrosymmetric, F will be real
      if (centro) then
        do 10 i = 1, n
10        fr(i) = 0.0
      else
        do 20 i = 1, n
          fi(i) = 0.0
20        fr(i) = 0.0
      end if
C compute scattering
      do 50 i = 1, n_atoms*n_symm
        k = (i-1)/n_symm + 1
        fact = a_occup(k)
        x = ta_pos(1,i)
        y = ta_pos(2,i)
        z = ta_pos(3,i)
        if (centro) then
          do 30 j = 1, n
            dot = rec_h(j)*x + rec_k(j)*y + rec_l(j)*z
            tmp = fact * scat(k,j)
30          fr(j) = fr(j) + tmp * cos(dot)
        else
          do 40 j = 1, n
            dot = rec_h(j)*x + rec_k(j)*y + rec_l(j)*z
            tmp = fact * scat(k,j)
            fr(j) = fr(j) + tmp * cos(dot)
40          fi(j) = fi(j) + tmp * sin(dot)
        end if
50      continue
C get intensity
      if (centro) then
        do 60 i = 1, n
60        inten(i) = fr(i)*fr(i)
      else
        do 70 i = 1, n
70        inten(i) = fr(i)*fr(i) + fi(i)*fi(i)
      end if
      return
      end


C This routine sums the intensities that need to be summed and
C scales the intensities by the multiplicities and the corrections.
C It then scales the intensities against the observed.
      subroutine SCALINT(inten, cor, isum, n)

      include 'zefsa3d.inc'
      include 'zefsa3d-b.inc'

      integer*2 n
      real*4 inten(MAX_SPOT), cor(MAX_SPOT), isum(MAX_SPOT)

      integer*2 i, j
      real*4 sum1, fact

C multiply by multiplicities
      do 10 i = 1, n
10      inten(i) = rec_mult(i) * cor(i) * inten(i)
C sum intensities that need to be
      do 20 i = 1, n
        j = i_point(i)
        if (j .ne. i) then
          inten(j) = inten(j) + inten(i)
          inten(i) = 0.0
        end if
20    continue
C scale the areas of the intensities to be the same
      sum1 = 0.0
      do 30 i = 1, n
30      sum1 = sum1 + inten(i)
      fact = isum(n) / sum1
      do 40 i = 1, n
40      inten(i) = fact * inten(i)
      return
      end


C This routine computes the sum of the weighted squares
      real*4 function SUMSQ(inten, int, sig, resid, n)

      include 'zefsa3d.inc'
      include 'zefsa3d-b.inc'

      integer*2 n
      real*4 inten(MAX_SPOT), int(MAX_SPOT), sig(MAX_SPOT),
     |       resid(MAX_SPOT)

      integer*2 i
      real*4 sum, x

      sum = 0.0
      do 10 i = 1, n
        x = 0.0
        if (i_point(i) .eq. i)
     |       x = (inten(i) - int(i)) / sig(i)
        resid(i) = x
10      sum = sum + x*x
      SUMSQ = sum
      return
      end


C This routine returns the energy associated with the unique positions in pos.
      real*4 function ENERGY2(pos, t)

      include 'zefsa3d.inc'
      include 'zefsa3d-b.inc'

      real*4 pos(3,MAX_UNIQ), t

      integer*2 n
      real*4 inten(MAX_SPOT), resid(MAX_SPOT), sum, SUMSQ

      external DO_SYM, GET_INT, SCALINT, SUMSQ

      n = max(min(int((rec_a + rec_b*t**rec_m) * n_spot), n_spot), 1)
      call DO_SYM(pos)
      call GET_INT(inten, scat_deb, n)
      call SCALINT(inten, rec_cor, rec_isum, n)
      sum = SUMSQ(inten, rec_int, rec_sig, resid, n)
      if (rad_type .eq. BOTH) then
        call GET_INT(inten, scat2_deb, n)
        call SCALINT(inten, rec2_cor, rec2_isum, n)
        sum = sum + SUMSQ(inten, rec2_int, rec2_sig, resid, n)
      end if
      ENERGY2 = sum
      return
      end


C This routine creates the positions subject to the matrix and vector
C conditions if pxd is set, otherwise it copies pos to pos2.
      subroutine POSMV(pos, pos2)

      include 'zefsa3d.inc'
      include 'zefsa3d-b.inc'

      real*4 pos(3,MAX_UNIQ), pos2(3, MAX_UNIQ)

      integer*2 i
      real*4 x, y, z

C remember that matrices are defined Column,Row
      if (pxd) then
        do 10 i = 1, n_atoms
          x = pos(1,i)
          y = pos(2,i)
          z = pos(3,i)
          pos2(1,i) = a_m(1,1,i)*x+a_m(2,1,i)*y+a_m(3,1,i)*z + a_v(1,i)
          pos2(2,i) = a_m(1,2,i)*x+a_m(2,2,i)*y+a_m(3,2,i)*z + a_v(2,i)
10        pos2(3,i) = a_m(1,3,i)*x+a_m(2,3,i)*y+a_m(3,3,i)*z + a_v(3,i)
      else
        do 20 i = 1, n_atoms
          pos2(1,i) = pos(1,i)
          pos2(2,i) = pos(2,i)
20        pos2(3,i) = pos(3,i)
      end if
C put atoms back in the unit cell
      do 30 i = 1, n_atoms
        pos2(1,i) = mod(mod(pos2(1,i)+1.0,1.0)+1.0,1.0)
        pos2(2,i) = mod(mod(pos2(2,i)+1.0,1.0)+1.0,1.0)
30      pos2(3,i) = mod(mod(pos2(3,i)+1.0,1.0)+1.0,1.0)
      return
      end


C This routine writes out the passed uniqe atoms possitions in CHEM-X
C CSSR format.
      logical function WR2_CSSR(unit, pos)

      include 'zefsa3d.inc'
      include 'zefsa3d-b.inc'

      integer*2 unit
      real*4 pos(3,MAX_UNIQ)

      character*4 ctmp, name(MAX_UNIQ)
      integer*2 i, j
      real*4 occup

      WR2_CSSR = .false.
C create atom names
      do 10 i = 1, n_atoms
        ctmp(1:2) = 'AT'
        ctmp(3:3) = char(48 + i/10)
        ctmp(4:4) = char(48 + mod(i,10))
10      name(i) = ctmp
C write out CSSR header
      write(unit,310,ERR=210) ' ',c_a, c_b, c_c
      write(unit,320,ERR=210)
     |   c_alpha*180.0/PI, c_beta*180.0/PI, c_gamma*180.0/PI
      write(unit,330,ERR=210) n_atoms, 0, 'ZEFSA3D'
      write(unit,340,ERR=210) 0,1,0,'ZEFSA3D'
C write out unit cell atoms
      do 70 i = 1, n_atoms
        ctmp = name(i)
        if (pxd) ctmp = a_name(i)
        occup = 0.0
        if (pxd) occup = a_occup(i)
70      write(unit,300,ERR=210) 0, ctmp, (pos(j,i),j=1,3),
     |     (0,j=1,8), occup, 1
      WR2_CSSR = .true.
80    close(unit)
      return
210   print *,'Error writing CSSR file'
      goto 80
300   format(I4, 1X, A4, 1X, 1X, 3(F9.5, 1X), 8I4, 1X, F7.3, 1X, I3)
310   format(22X, A6, 10X, F8.3, F8.3, F8.3)
320   format(21X, 3F8.3)
330   format(2I4, 1X, A60)
340   format(I4, I2, I1, A60)
      end


C This routine writes out the calculated and observed intensities
      logical function WR_PXD(unit, pos)

      include 'zefsa3d.inc'
      include 'zefsa3d-b.inc'

      integer*2 unit
      real*4 pos(3,MAX_UNIQ)

      integer*2 i
      real*4 x, inten(MAX_SPOT), inten2(MAX_SPOT), resid(MAX_SPOT),
     |       resid2(MAX_SPOT), PI2, y, SUMSQ, z

      external DO_SYM, GET_INT, SCALINT, SUMSQ

      WR_PXD = .false.
      PI2 = 2.0D0 * PI
      call DO_SYM(pos)
      call GET_INT(inten, scat_deb, n_spot)
      call SCALINT(inten, rec_cor, rec_isum, n_spot)
      x = SUMSQ(inten, rec_int, rec_sig, resid, n_spot)
      if (rad_type .eq. BOTH) then
        call GET_INT(inten2, scat2_deb, n_spot)
        call SCALINT(inten2, rec2_cor, rec2_isum, n_spot)
        x = SUMSQ(inten2, rec2_int, rec2_sig, resid2, n_spot)
      end if
      do 10 i = 1, n_spot
        if (i_point(i) .eq. i) then
          y = asin(0.5*rad_lamb * sqrt(rec_q2(i)))
          if (rad_type .ne. BOTH) then
            write(unit, 100, ERR=20) rec_h(i)/PI2, rec_k(i)/PI2,
     |                rec_l(i)/PI2, y, inten(i), rec_int(i), resid(i)
          else
            z = asin(0.5*rad2_lamb * sqrt(rec_q2(i)))
            write(unit, 100, ERR=20) rec_h(i)/PI2, rec_k(i)/PI2,
     |                rec_l(i)/PI2, y, inten(i), rec_int(i), resid(i),
     |                z, inten2(i), rec2_int(i), resid2(i)
          end if
        end if
10      continue
      WR_PXD = .true.
      return
20    print *,'Error writing PXD file'
      return
100   format(20F12.5)
      end


C This routine prints out the chemical formula of the structure
      subroutine CHEMFORM(unit)

      include 'zefsa3d.inc'
      include 'zefsa3d-b.inc'

      integer*2 unit

      logical seen(MAX_UNIQ)
      character*4 name(MAX_UNIQ)
      integer*2 i, j, n, num(MAX_UNIQ)
      real*4 occup

C clear marks
      do 10 i = 1, n_atoms
10      seen(i) = .false.
      n = 0
C loop through all names not already seen
      do 30 i = 1, n_atoms
        if (.not. seen(i)) then
          occup = 0.0
C see how many same-named atoms there are
          do 20 j = i, n_atoms
            if (a_name(i) .eq. a_name(j)) then
              occup = occup + a_occup(j)
              seen(j) = .true.
            end if
20          continue
C add one more unique name/number pair to the found list
          n = n + 1
          num(n) = nint(occup*n_symm)
          name(n) = a_name(i)
        end if
30      continue
C print out found formula
      write(unit,100) (name(i), i = 1, n)
      write(unit,110) (num(i), i = 1, n)
      return
100   format(1X, 'Chemical formula per unit cell is ', 20(A4,3X))
110   format(1X, '                                  ', 20(4X,I3))
      end
