/*

  (C) 1997 Marco Falcioni

  trial: implementation

*/


#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "constants.h"

#include "error.h"
#include "trial.h"
#include "misc.h"

struct Trial * new_Trial(double radius)
{
  struct Trial * me;

  me = (struct Trial *) Malloc(sizeof(struct Trial));

  me->radius = radius;

  me->dx = me->radius * gasdev();
  me->dy = me->radius * gasdev();
  me->dz = me->radius * gasdev();

  return me;
}


INLINE
struct Trial * reverse_Trial(struct Trial * me) 
{
  me->dx = - me->dx;
  me->dy = - me->dy;
  me->dz = - me->dz;
  return me;
}


INLINE
struct Trial * renew_Trial(struct Trial * me) 
{
 
  me->dx = me->radius * gasdev();
  me->dy = me->radius * gasdev();
  me->dz = me->radius * gasdev();

  return me;

}

void print_Trial(struct Trial * me, FILE * stream)
{
  if(me == 0 || stream == 0) {
    push_generic_error("print_Trial","(nil) argument passed");
  }
  fprintf(stream, "%e %e %e %e\n", me->dx, me->dy, me->dz, me->radius * 0.5);
  return;
}

void delete_Trial(struct Trial * me) 
{
  if(me != 0)
    Free(me);
  return;
}

/* test program 

int main (void) 
{
  int i = 10000;
  struct Trial * a;

  a = new_Trial(50);

  for(; i > 0 ; i --) {
    print_Trial(a, stdout);
    renew_Trial(a);
  }

  return 0;
}
*/

