/*

  (C) 1997 Marco Falcioni (falcioni@ucla.edu)

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
  USA.

  http://www.fsf.org/copyleft/gpl.html


*/
/*

  (C) 1997 Marco Falcioni

*/

#include <stdio.h>
#include <stdlib.h>

#include "error.h"

#include "misc.h"

#include "intensity.h"



struct Intensity * new_Intensity(void) 
{
  struct Intensity * me;

  me = (struct Intensity *) Malloc(sizeof(struct Intensity));
  if( me == 0 ) {
    push_error("new_Intensity",Error_Alloc_);
    exit_clean();
  }

  me->composite = 0;
  me->value = 0.0;
  me->calc = 0.0;
  me->sigma = 0;

  return me;
}
void delete_Intensity(struct Intensity * me)
{
  if(me == 0) return;
  Free(me);
  return;
}

void print_Intensity(const struct Intensity * me, FILE * const stream)
{
  if(stream == 0) {
    push_generic_error("print_Intensity", "(nil) arg passed");
    exit_clean();
  }

  if(me == 0) return;

  fprintf(stream,"\t%15.7e %2d %15.7e", me->value, (int) me->sigma, 
	  me->calc);
  return;
}

void copy_Intensity(const struct Intensity * me, struct Intensity * to_me)
{
  if(me == 0 || to_me == 0) {
    push_generic_error("copy_Intensity", "(nil) arg passed");
    exit_clean();
  }
  
  to_me->calc = me->calc;
  to_me->value = me->value;
  to_me->sigma = me->sigma;

  to_me->composite = 0;
  return;

}
