/*

  (C) 1998 Marco Falcioni UCLA
  
  some macros for code readability


  (C) 1997 Marco Falcioni (falcioni@ucla.edu)

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
  USA.

  http://www.fsf.org/copyleft/gpl.html



 */

#include "oogl.h"
#include "positions.h"
#include "grid.h"


/* macros for convenience */

#define OOGLCONFG(stream, T1, T2, P, C, G, Gr)  \
    oogl_Init_list(stream);                     \
    copy_Positions(T1,T2);                      \
    symmetrize_Positions(T2, G);                \
    mod_Positions(T2);                          \
    merge_positions(T2, P, C);                  \
    clean_Grid(Gr);                             \
    fill_Grid(Gr, T2, C);                       \
    oogl_Cell(C,0);                             \
    oogl_bonds(P, C, T2, Gr,0);                 \
    oogl_Grid(Gr,C);                            \
    oogl_Finish_list();

#define OOGLCONFP(stream, T1, T2, P, C, G, Gr)  \
    oogl_Init_list(stream);                     \
    copy_Positions(T1,T2);                      \
    symmetrize_Positions(T2, G);                \
    mod_Positions(T2);                          \
    merge_positions(T2, P, C);                  \
    clean_Grid(Gr);                             \
    fill_Grid(Gr, T2, C);                       \
    oogl_Cell(C,0);                             \
    oogl_bonds(P, C, T2, Gr,0);                 \
    oogl_Positions(T2, C, 1);                      \
    oogl_Finish_list();

#define OOGLCONFM(stream, T1, T2, P, C, G, Gr)  \
    oogl_Init_list(stream);                     \
    copy_Positions(T1,T2);                      \
    symmetrize_Positions(T2, G);                \
    mod_Positions(T2);                          \
    merge_positions(T2, P, C);                  \
    clean_Grid(Gr);                             \
    fill_Grid(Gr, T2, C);                       \
    oogl_Cell(C,0);                             \
    oogl_bonds(P, C, T2, Gr,0);                 \
    oogl_Positions(T2, C, 0);                   \
    mod_all_Molecules(T2->Nmol, T2->M, C);      \
    oogl_all_Molecules(T2->Nmol, T2->M, C, 0);  \
    oogl_Finish_list();
