/* Created: [GJ] Mon Feb 10 08:33:27 EST 1997
 */
#ifndef MEMORY_H_
#define MEMORY_H_


/* allocate a vector of ints */
extern int  * new_vector_i(unsigned long size);

/* allocate a vector of longs */
extern long * new_vector_l(unsigned long size);

/* allocate a vector of doubles */
extern double * new_vector_d(unsigned long size);

/* allocate a vector of floats */
extern float  * new_vector_f(unsigned long size);

/* allocate a vector of chars */
extern char * new_vector_c(unsigned long size);



/* allocate a vector of (int *)s */
extern int  ** new_vector_ip(unsigned long size);

/* allocate a vector of (long *)s */
extern long ** new_vector_lp(unsigned long size);

/* allocate a vector of (double *)s */
extern double ** new_vector_dp(unsigned long size);

/* allocate a vector of (float *)s */
extern float  ** new_vector_fp(unsigned long size);

/* allocate a vector of (char *)s */
extern char ** new_vector_cp(unsigned long size);

/* free a vector allocated by one of the above */
extern void free_vector(void * p);



/* allocate a square matrix of ints */
extern int  ** new_matrix_i(unsigned long size);

/* allocate a square matrix of longs */
extern long ** new_matrix_l(unsigned long size);

/* allocate a square matrix of doubles */
extern double ** new_matrix_d(unsigned long size);

/* allocate a square matrix of floats */
extern float  ** new_matrix_f(unsigned long size);


/* free a matrix of ints */
extern void free_matrix_i(int ** m, unsigned long size);

/* free a matrix of longs */
extern void free_matrix_l(long ** m, unsigned long size);

/* free a matrix of doubles */
extern void free_matrix_d(double ** m, unsigned long size);

/* free a matrix of floats */
extern void free_matrix_f(float ** m, unsigned long size);


/* copy a vector of ints, allocating */
extern int  * copy_vector_i(int * v, unsigned long size);

/* copy a vector of longs, allocating */
extern long * copy_vector_l(long * v, unsigned long size);

/* copy a vector of doubles, allocating */
extern double * copy_vector_d(double * v, unsigned long size);

/* copy a vector of floats, allocating */
extern float  * copy_vector_f(float * v, unsigned long size);

/* copy a vector of chars, allocating */
extern char * copy_vector_c(char * v, unsigned long size);



/* copy a matrix of ints, allocating */
extern int  ** copy_matrix_i(int ** v, unsigned long size);

/* copy a matrix of longs, allocating */
extern long ** copy_matrix_l(long ** v, unsigned long size);

/* copy a matrix of doubles, allocating */
extern double ** copy_matrix_d(double ** v, unsigned long size);

/* copy a matrix of floats, allocating */
extern float  ** copy_matrix_f(float ** v, unsigned long size);



#endif /* MEMORY_H_ */
