/* Created: [GJ] Fri Jan 17 17:06:58 EST 1997
 */
#ifndef SORTING_H_
#define SORTING_H_

#define Max(a,b) ((a) > (b) ? (a) : (b))
#define Min(a,b) ((a) < (b) ? (a) : (b))


/* Determine max/min of a set of numbers. */
extern double maxReal(const double * x, unsigned long size);
extern double minReal(const double * x, unsigned long size);
extern void   minmaxReal(const double * x, unsigned long size,
			 double * min, double * max);

extern int  maxInt(const int * x, unsigned long size);
extern int  minInt(const int * x, unsigned long size);
extern void minmaxInt(const int * x, unsigned long size,
		      int * min, int * max);

/* Heapsort a vector of numbers. */
extern void heapsortReal(double * v, unsigned long size);
extern void heapsortInt(int * v, unsigned long size);

/* Create a sorting map for a vector of numbers. */
extern void heapsortmapReal(double *v, unsigned long size, unsigned long *map);
extern void heapsortmapInt(int *v, unsigned long size, unsigned long * map);


#endif /* SORTING_H_ */
