/* 
   (C) 1998 Marco Falcioni UCLA


   little verbose stuff

   (C) 1998 Marco Falcioni (falcioni@ucla.edu)

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
  USA.

  http://www.fsf.org/copyleft/gpl.html

*/

#include <stdio.h>
#include <string.h>

#include "error.h"
#include "verbose.h"


static FILE * verb_str = 0;
static unsigned int verbose = 0; 
static char * progname = 0;

static char verb_message[1024] = "";

void connect_verbose_stream(FILE * stream, char * name)
{
  if(stream == 0) {
    push_generic_error("connect_verbose_stream", "(nil) arg passed");
    exit_clean();
  }
  progname = name;
  verbose = 1;
  verb_str = stream;
  return;
}

void push_verbose_message(const char * prefix, const char * mess)
{
  size_t len_mess = strlen(mess);
  size_t len = (len_mess > 1024 ? 1024 : len_mess);

  if(verbose == 0) return;

  strncpy(verb_message, mess, len+1);
  
  if(verb_str != (FILE *)0) {
    fprintf(verb_str,"%s.%s: INFO: %s\n",
	    progname,
	    prefix,
	    verb_message
	    );
    fflush(verb_str);
  }
}

FILE * verbose_stream(void) 
{
  if(verbose == 0) return 0;
  return verb_str;

}
