/*

  this program takes an XTL file and writes a zefsa input file.
  
  not very robust...
  
  (C) 1998 Marco Falcioni (falcioni@ucla.edu)

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
  USA.

  http://www.fsf.org/copyleft/gpl.html

*/

#include <stdio.h>
#include <math.h>
#include "resources.h"
#include "stringlib.h"
#include "cell.h"
#include "group.h"
#include "positions.h"
#include "symmetry.h"
#include "params.h"
#include "rad_pattern.h"
#include "functions.h"
#include "error.h" /* from libgjm-1.3 */
#include "verbose.h"

int main (int argc , char ** argv)
{
  int i;
  struct Params * P;
  struct Sym_group * G;
  struct Cell * C;
  struct Positions * T;
  
  struct string_list * options;

  connect_error_stream(stderr, argv[0]);

  options = append_string_to_list(0, "v");

  args_to_resources(argc, argv, options);

  if(extract_global_resource("v")) connect_verbose_stream(stderr, argv[0]);

  P = read_Params(stdin);

  T = init_Positions(stdin);
  
  read_XTL(T, &C, &G, stdin);

  if(is_csym_Sym_group(G)) C->csym = 1;

  write_Params(P, stdout);

  printf("%ld %ld %ld\n", T->n_unique, T->n_symmetry, T->n_actual);
  for(i = 0; i < T->n_unique; i++) printf("4 ");
  printf("\n");

  write_Cell(C,stdout);
  write_Sym_group(G, stdout);
  write_unique_Positions(T,stdout);

  return 0;

}
